<?php

/*
Plugin Name: WP Easy Translate
Plugin URI: https://www.expressware.co
Description: Sell Internationally
Version: 1.0.1
Author: Michael Thomas
Author URI: https://www.expressware.co
License: Proprietary
*/

namespace WPEasyTranslate;

require __DIR__ . '/vendor/autoload.php';

use WPEasyTranslate\View\Footer;
use WPEasyTranslate\View\Settings;
use WPEasyTranslate\Model\Settings as SettingsModel;

class Plugin extends \MetatickPluginLib\Plugin
{
    static $config = null;
    static $instance = null;
    static $license = null;
    static $template_loader = null;
    static $template_engine = null;

    const NAME = 'WP Easy Translate';
    const SLUG = 'wp-easy-translate';

    const FILE = __FILE__;
    const PATH = __DIR__;

    static $settings = null;

    public function __construct(){
        self::license();
        $template_path = self::path('templates');

        new Settings($template_path);
        if(self::license()->is_licensed()) {
            new Footer($template_path);
        }
    }

    public static function settings(){
        if(!static::$settings){
            static::$settings = new SettingsModel();
        }
        return static::$settings;
    }
}

Plugin::run();