<?php

namespace MetatickPluginLib\Model;

class OptionModel extends Model {

    protected $option = '';
    protected $network = false;

    public function __construct()
    {
        $this->initialize(static::OPTION, static::NETWORK);
    }

    public function initialize($option, $network = false) {
        $this->option  = $option;
        $this->network = $network;

        if ($this->network) {
            $this->properties = get_site_option($this->option, []);
        } else {
            $this->properties = get_option($this->option, []);
        }
    }

    public function save() {
        if ($this->network) {
            update_site_option($this->option, $this->properties);
        } else {
            update_option($this->option, $this->properties);
        }
    }
}