<?php


namespace MetatickPluginLib\Request;


class Request
{
    protected $get = null;
    protected $post = null;
    protected $cookies = null;
    protected $headers = null;

    public function __construct()
    {
        $this->get = new RequestParams($_GET);
        $this->post = new RequestParams($_POST);
        $this->cookies = new RequestParams($_COOKIE);
        $this->headers = new RequestParams($_COOKIE, true);
    }

    public function GET(){
        return $this->get;
    }

    public function POST(){
        return $this->post;
    }

    public function COOKIES(){
        return $this->cookies;
    }

    public function HEADERS(){
        return $this->headers;
    }

    public function scheme(){
        return $_SERVER['REQUEST_SCHEME'];
    }

    public function host(){
        return $_SERVER['HTTP_HOST'];
    }

    public function uri(){
        return $_SERVER['REQUEST_URI'];
    }

    public function path(){
        return parse_url($_SERVER['REQUEST_URI'], PHP_URL_PATH);
    }

    public function query(){
        return $_SERVER['QUERY_STRING'];
    }

    public function url(){
        return sprintf("%s://%s%s", $this->scheme(), $this->host(), $this->uri());
    }

    public function referer(){
        if(array_key_exists('HTTP_REFERER', $_SERVER)){
            return $_SERVER['HTTP_REFERER'];
        }
        return null;
    }

    protected static $instance = null;

    public static function instance(){
        if(!static::$instance){
            static::$instance = new Request();
        }
        return static::$instance;
    }
}

